> For the complete documentation index, see [llms.txt](https://docs.mailtrap.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.mailtrap.io/developers/email-marketing/contacts/bulk-import/import-contacts.md).

# Import contacts

Import contacts in bulk with support for custom fields and list management. Existing contacts with matching email addresses will be updated automatically. You can import up to 50,000 contacts per request. The import process runs asynchronously - use the returned import ID to check the status and results.

```json
{"openapi":"3.1.0","info":{"title":"Contacts","version":"2.0.0"},"tags":[{"name":"Bulk Import","description":"Manage contact import jobs"}],"servers":[{"description":"Mailtrap API","url":"https://mailtrap.io"}],"security":[{"HeaderAuth":[]},{"BearerAuth":[]}],"components":{"securitySchemes":{"HeaderAuth":{"type":"apiKey","description":"Pass the API token in the Api-Token","in":"header","name":"Api-Token"},"BearerAuth":{"type":"http","scheme":"bearer","bearerFormat":"JWT"}},"schemas":{"ContactImportRequest":{"title":"Contact Import Request","type":"object","properties":{"contacts":{"type":"array","items":{"type":"object","properties":{"email":{"type":"string"},"fields":{"type":"object","description":"Object of fields in the following format:\n  field_merge_tag: string | integer | float | boolean | date string in ISO-8601 format (yyyy-mm-dd);"},"list_ids_included":{"type":"array","items":{"type":"integer"}},"list_ids_excluded":{"type":"array","items":{"type":"integer"}}}}}}},"ContactImport":{"type":"object","properties":{"id":{"type":"integer"},"status":{"type":"string","enum":["created","started","finished","failed"]},"created_contacts_count":{"type":"integer","description":"_optional_, provided only if __status__ is `finished`"},"updated_contacts_count":{"type":"integer","description":"_optional_, provided only if __status__ is `finished`"},"contacts_over_limit_count":{"type":"integer","description":"_optional_, provided only if __status__ is `finished`"}}},"UnauthenticatedResponse":{"title":"UnauthenticatedResponse","type":"object","properties":{"error":{"type":"string","description":"Error message"}}},"PermissionsDeniedResponse":{"title":"PermissionsDeniedResponse","type":"object","properties":{"errors":{"type":"string"}}},"ContactImportErrors":{"title":"UnprocessableEntity","type":"object","properties":{"errors":{"type":"array","items":{"type":"object","properties":{"email":{"type":"string"},"errors":{"type":"object","properties":{"base":{"type":"array","items":{"type":"string"}},"email":{"type":"array","items":{"type":"string"}},"fields":{"type":"array","items":{"type":"string"}},"field_merge_tag":{"type":"array","items":{"type":"string"}}}}}}}}},"ErrorResponse":{"title":"ErrorResponse","type":"object","properties":{"errors":{"type":"string","description":"Error message"}}}},"responses":{"UNAUTHENTICATED":{"description":"Returns unauthorized error message. Check your credentials.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/UnauthenticatedResponse"}}}},"PERMISSION_DENIED":{"description":"Returns forbidden error message. Check your permissions.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/PermissionsDeniedResponse"}}}},"INTERNAL_ERROR":{"description":"Internal error. Retry later or contact support.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ErrorResponse"}}}}}},"paths":{"/api/contacts/imports":{"post":{"description":"Import contacts in bulk with support for custom fields and list management. Existing contacts with matching email addresses will be updated automatically. You can import up to 50,000 contacts per request. The import process runs asynchronously - use the returned import ID to check the status and results.","operationId":"importContacts","summary":"Import contacts","tags":["Bulk Import"],"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ContactImportRequest"}}}},"responses":{"201":{"description":"Contact Import created successfully.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ContactImport"}}}},"401":{"$ref":"#/components/responses/UNAUTHENTICATED"},"403":{"$ref":"#/components/responses/PERMISSION_DENIED"},"422":{"description":"Returns validation errors.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/ContactImportErrors"}}}},"500":{"$ref":"#/components/responses/INTERNAL_ERROR"}}}}}}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.mailtrap.io/developers/email-marketing/contacts/bulk-import/import-contacts.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
